﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace SmoothScriptedAnimation
{
	public partial class BlueCircle : UserControl
	{
        private static Random randomMain = new Random();

        private double angle;
        private double speed;

        private double xPos;
        private double yPos;

		public BlueCircle()
		{
			// Required to initialize variables
			InitializeComponent();

            this.Loaded += new RoutedEventHandler(CircleLoaded);
		}

        void CircleLoaded(object sender, RoutedEventArgs e)
        {
            xPos = Canvas.GetLeft(this);
            yPos = Canvas.GetTop(this);

            speed = .01 + randomMain.NextDouble();

            if (DesignerProperties.GetIsInDesignMode(this) == false)
            {
                CompositionTarget.Rendering += new EventHandler(AnimateCircle);
            }
        }

        void AnimateCircle(object sender, EventArgs e)
        {
            angle += speed/10;

            Canvas.SetTop(this, yPos + 50 * Math.Sin(angle));
            Canvas.SetLeft(this, xPos + 50 * Math.Cos(angle));

            if (angle >= 2 * Math.PI)
            {
                angle = 0;
            }
        }
	}
}